const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const badges = sequelize.define(
    'badges',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

rarity: {
        type: DataTypes.ENUM,
      
      

        values: [

"common",


"rare",


"epic",


"legendary"

        ],

      },

points_awarded: {
        type: DataTypes.INTEGER,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  badges.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



























    db.badges.hasMany(db.user_badges, {
      as: 'user_badges_badge',
      foreignKey: {
          name: 'badgeId',
      },
      constraints: false,
    });






//end loop



    db.badges.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });



    db.badges.hasMany(db.file, {
      as: 'icon_image',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.badges.getTableName(),
        belongsToColumn: 'icon_image',
      },
    });


    db.badges.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.badges.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return badges;
};


